package com.bjsxt.dao.impl;

import com.bjsxt.commons.JdbcUtils;
import com.bjsxt.dao.UserManageDao;
import com.bjsxt.pojo.Users;

import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.util.ArrayList;
import java.util.List;

public class UserManageDaoImpl implements UserManageDao {
    @Override
    public void insetUser(Users user) {
        Connection conn=null;
        try{
            conn= JdbcUtils.getConnection();
            conn.setAutoCommit(false);
            PreparedStatement ps = conn.prepareStatement("insert into users value(default,?,?,?,?,?)");
            ps.setString(1,user.getUsername());
            ps.setString(2,user.getUserpwd());
            ps.setString(3,user.getUsersex());
            ps.setString(4,user.getPhonenumber());
            ps.setString(5,user.getQqnumber());
            ps.execute();
            conn.commit();
        }catch(Exception e){
            JdbcUtils.rollbackConnection(conn);
            e.printStackTrace();
        }finally {
            JdbcUtils.closeConnection(conn);
        }
    }

    /**
     * 查询用户
     * @param users
     * @return
     */
    @Override
    public List<Users> selectUserByProperty(Users users) {
        Connection coon=null;
        List<Users>list=new ArrayList<>();
        try{
            coon=JdbcUtils.getConnection();
            String sql=this.createSQL(users);
            PreparedStatement ps = coon.prepareStatement(sql);
            ResultSet resultSet = ps.executeQuery();
            while(resultSet.next()){
                Users user=new Users();
                user.setUsername(resultSet.getString("username"));
                user.setUsersex(resultSet.getString("usersex"));
                user.setPhonenumber(resultSet.getString("phonenumber"));
                user.setQqnumber(resultSet.getString("qqnumber"));
                user.setUserpwd(resultSet.getString("userpwd"));
                user.setUserid(resultSet.getInt("userid"));
                list.add(user);
            }

        }catch(Exception e){
            e.printStackTrace();
        }finally {
            JdbcUtils.closeConnection(coon);
        }
        return list;
    }


    /**
     * 拼接查询的SQL语句
     */
    private String createSQL(Users users){
        StringBuffer stringBuffer=new StringBuffer("select * from users where 1=1");
        if(users.getPhonenumber()!=null&&users.getPhonenumber().length()>0){
            stringBuffer.append(" and phonenumber = '"+users.getPhonenumber()+"'");
        }
        if(users.getQqnumber()!=null && users.getQqnumber().length()>0){
            stringBuffer.append(" and qqnumber = '"+users.getQqnumber()+"'");
        }
        if(users.getUsername()!=null&&users.getUsername().length()>0){
            stringBuffer.append(" and username = '"+users.getUsername()+"'");
        }
        if(users.getUsersex()!=null && users.getUsersex().length()>0){
            stringBuffer.append(" and usersex = '"+users.getUsersex()+"'");
        }
        return stringBuffer.toString();
    }
}
