package com.bjsxt.web.servlet;

import com.bjsxt.pojo.Users;
import com.bjsxt.service.UserManageService;
import com.bjsxt.service.impl.UserManageServiceImpl;
import com.sun.org.apache.bcel.internal.ExceptionConst;

import javax.servlet.ServletException;
import javax.servlet.annotation.WebServlet;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.io.IOException;
import java.util.List;

/**
 * 处理用户管理请求
 */
@WebServlet("/userManager.do")
public class UserManageServlet extends HttpServlet{
    @Override
    protected void doGet(HttpServletRequest req, HttpServletResponse resp) throws ServletException, IOException {
        this.doPost(req,resp);
    }

    @Override
    protected void doPost(HttpServletRequest req, HttpServletResponse resp) throws ServletException, IOException {
        String flag=req.getParameter("flag");
        if("addUser".equals(flag)){
            this.addUser(req,resp);
        }else if("findUser".equals(flag)){
            this.findUser(req,resp);
        }
    }

    //处理添加用户请求
    private void addUser(HttpServletRequest req, HttpServletResponse resp) throws ServletException, IOException{
            Users user=this.createUsers(req);
            try{
                UserManageService userManageService=new UserManageServiceImpl();
                userManageService.addUser(user);
                resp.sendRedirect("ok.jsp");
            }catch(Exception e){
                e.printStackTrace();
                resp.sendRedirect("error.jsp");
            }

    }
    //获取用户提交数据
    private  Users createUsers(HttpServletRequest req){
        String username=req.getParameter("Username");
        String userpwd=req.getParameter("userpwd");
        String usersex=req.getParameter("usersex");
        String phonenumber=req.getParameter("phonenumber");
        String qqnumber=req.getParameter("qqnumber");

        Users users=new Users();
        users.setQqnumber(qqnumber);
        users.setPhonenumber(phonenumber);
        users.setUsersex(usersex);
        users.setUserpwd(userpwd);
        users.setUsername(username);

        return users;
    }

    /**
     * 处理查询用户请求
     */
    private void findUser(HttpServletRequest req, HttpServletResponse resp) throws ServletException, IOException{
        Users user=this.createUsers(req);
        try{
            UserManageService userManageService=new UserManageServiceImpl();
            List<Users>list=userManageService.findUser(user);
            req.setAttribute("list",list);
            req.getRequestDispatcher("usermanager/viewUser.jsp").forward(req,resp);
        }catch(Exception e){
            e.printStackTrace();
            resp.sendRedirect("error.jsp");
        }
    }
}
